define({ "api": [
  {
    "type": "get",
    "url": "/realmedialibrary/v1/posts/:id/shortcutInfo",
    "title": "Get the shortcut container",
    "name": "GetAttachmentShortcutInfo",
    "group": "Attachment",
    "version": "1.0.0",
    "filename": "inc/rest/Attachment.class.php",
    "groupTitle": "Attachment",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/posts/:id/shortcutInfo"
      }
    ]
  },
  {
    "type": "put",
    "url": "/realmedialibrary/v1/attachments/:id",
    "title": "Update an attachment by id",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "folderId",
            "description": "<p>The folder id</p>"
          },
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "attachmentId",
            "description": "<p>The attachment id</p>"
          },
          {
            "group": "Parameter",
            "type": "int",
            "optional": true,
            "field": "nextId",
            "description": "<p>The next id relative to the attachment</p>"
          },
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "lastId",
            "description": "<p>The last id in the current sortable view</p>"
          }
        ]
      }
    },
    "name": "UpdateAttachment",
    "group": "Attachment",
    "version": "1.0.0",
    "filename": "inc/rest/Attachment.class.php",
    "groupTitle": "Attachment",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/attachments/:id"
      }
    ]
  },
  {
    "type": "put",
    "url": "/realmedialibrary/v1/attachments/bulk/move",
    "title": "Move/Copy multipe attachments",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "int[]",
            "optional": false,
            "field": "ids",
            "description": "<p>The post ids to move / copy</p>"
          },
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "to",
            "description": "<p>The term id</p>"
          },
          {
            "group": "Parameter",
            "type": "boolean",
            "optional": false,
            "field": "isCopy",
            "description": "<p>If true the post is appended to the category</p>"
          }
        ]
      }
    },
    "name": "UpdatePostBulkMove",
    "group": "Attachment",
    "version": "1.0.0",
    "filename": "inc/rest/Attachment.class.php",
    "groupTitle": "Attachment",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/attachments/bulk/move"
      }
    ]
  },
  {
    "type": "post",
    "url": "/realmedialibrary/v1/folders/content/sortable",
    "title": "Set a folders content order",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "string",
            "optional": false,
            "field": "id",
            "description": "<p>The sortable id. Pass &quot;original&quot; to reset the folder, pass &quot;deactivate&quot; to deactive the automatic order, pass &quot;reindex&quot; to reindex the order indexes, pass &quot;last&quot; to try to to reset to the last available order</p>"
          },
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "applyTo",
            "description": "<p>The folder id</p>"
          },
          {
            "group": "Parameter",
            "type": "boolean",
            "optional": true,
            "field": "automatically",
            "description": "<p>Automatically use this order when new files are added to the folder</p>"
          }
        ]
      }
    },
    "name": "ApplyFolderContentSorting",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Folder.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/folders/content/sortable"
      }
    ]
  },
  {
    "type": "post",
    "url": "/realmedialibrary/v1/folders",
    "title": "Create a new folder",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "string",
            "optional": false,
            "field": "name",
            "description": "<p>The new name for the folder</p>"
          },
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "parent",
            "description": "<p>The parent</p>"
          },
          {
            "group": "Parameter",
            "type": "string",
            "optional": false,
            "field": "type",
            "description": "<p>The folder type</p>"
          }
        ]
      }
    },
    "name": "DeleteFolder",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Folder.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/folders"
      }
    ]
  },
  {
    "type": "delete",
    "url": "/realmedialibrary/v1/folders/:id",
    "title": "Delete a folder by id",
    "name": "DeleteFolder",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Folder.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/folders/:id"
      }
    ]
  },
  {
    "type": "get",
    "url": "/realmedialibrary/v1/folders/content/counts",
    "title": "Get all folder counts",
    "name": "GetFolderContentCounts",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Folder.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/folders/content/counts"
      }
    ]
  },
  {
    "type": "get",
    "url": "/realmedialibrary/v1/folders/content/sortable",
    "title": "Get the available sortables",
    "name": "GetFolderContentSortables",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Folder.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/folders/content/sortable"
      }
    ]
  },
  {
    "type": "get",
    "url": "/realmedialibrary/v1/folders/:id/meta",
    "title": "Get the HTML meta content",
    "name": "GetFolderMeta",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Folder.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/folders/:id/meta"
      }
    ]
  },
  {
    "type": "get",
    "url": "/realmedialibrary/v1/usersettings",
    "title": "Get the HTML for user settings",
    "name": "GetUserSettingsHTML",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Service.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/usersettings"
      }
    ]
  },
  {
    "type": "put",
    "url": "/realmedialibrary/v1/folders/:id",
    "title": "Update a folder by id",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "string",
            "optional": false,
            "field": "name",
            "description": "<p>The new name for the folder</p>"
          }
        ]
      }
    },
    "name": "UpdateFolder",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Folder.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/folders/:id"
      }
    ]
  },
  {
    "type": "put",
    "url": "/realmedialibrary/v1/folders/:id/meta",
    "title": "Update meta of a folder",
    "description": "<p>Send a key value map of form data so Meta implementations (IMetadata) can handle it</p>",
    "name": "UpdateFolderMeta",
    "group": "Folder",
    "version": "1.0.0",
    "filename": "inc/rest/Folder.class.php",
    "groupTitle": "Folder",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/folders/:id/meta"
      }
    ]
  },
  {
    "type": "get",
    "url": "/realmedialibrary/v1/plugin",
    "title": "Get plugin information",
    "header": {
      "fields": {
        "Header": [
          {
            "group": "Header",
            "type": "string",
            "optional": false,
            "field": "X-WP-Nonce",
            "description": ""
          }
        ]
      }
    },
    "name": "GetPlugin",
    "group": "Plugin",
    "success": {
      "examples": [
        {
          "title": "Success-Response:",
          "content": "{\n    WC requires at least: \"\",\n    WC tested up to: \"\",\n    Name: \"WP ReactJS Starter\",\n    PluginURI: \"https://matthias-web.com/wordpress\",\n    Version: \"0.1.0\",\n    Description: \"This WordPress plugin demonstrates how to setup a plugin that uses React and ES6 in a WordPress plugin. <cite>By <a href=\"https://matthias-web.com\">Matthias Guenter</a>.</cite>\",\n    Author: \"<a href=\"https://matthias-web.com\">Matthias Guenter</a>\",\n    AuthorURI: \"https://matthias-web.com\",\n    TextDomain: \"wp-reactjs-starter\",\n    DomainPath: \"/languages\",\n    Network: false,\n    Title: \"<a href=\"https://matthias-web.com/wordpress\">WP ReactJS Starter</a>\",\n    AuthorName: \"Matthias Guenter\"\n}",
          "type": "json"
        }
      ]
    },
    "version": "0.1.0",
    "filename": "inc/rest/Service.class.php",
    "groupTitle": "Plugin",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/plugin"
      }
    ]
  },
  {
    "type": "get",
    "url": "/realmedialibrary/v1/export",
    "title": "Get exported folders as JSON string",
    "name": "Export",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/export"
      }
    ]
  },
  {
    "type": "post",
    "url": "/realmedialibrary/v1/import",
    "title": "Set exported folders as RML folders",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "string",
            "optional": false,
            "field": "import",
            "description": "<p>The JSON import string</p>"
          }
        ]
      }
    },
    "name": "Import",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/import"
      }
    ]
  },
  {
    "type": "post",
    "url": "/realmedialibrary/v1/reset/migration",
    "title": "Do a upgrade command",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "string",
            "optional": false,
            "field": "build",
            "description": "<p>The migration build number</p>"
          }
        ]
      }
    },
    "name": "ImportTaxonomy",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/reset/migration"
      }
    ]
  },
  {
    "type": "post",
    "url": "/realmedialibrary/v1/import/taxonomy",
    "title": "Import a taxonomy to RML folders with relations to files",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "string",
            "optional": false,
            "field": "import",
            "description": "<p>The JSON import string</p>"
          }
        ]
      }
    },
    "name": "ImportTaxonomy",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/import/taxonomy"
      }
    ]
  },
  {
    "type": "delete",
    "url": "/realmedialibrary/v1/reset/count",
    "title": "Resets the count of all available folders",
    "name": "ResetCount",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/reset/count"
      }
    ]
  },
  {
    "type": "delete",
    "url": "/realmedialibrary/v1/reset/folders",
    "title": "Deletes all available folders with relations",
    "name": "ResetFolders",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/reset/folders"
      }
    ]
  },
  {
    "type": "delete",
    "url": "/realmedialibrary/v1/reset/order",
    "title": "Resets the order of all available folders",
    "name": "ResetOrder",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/reset/order"
      }
    ]
  },
  {
    "type": "delete",
    "url": "/realmedialibrary/v1/reset/relations",
    "title": "Resets the relations of all available folders to attachments",
    "name": "ResetRelations",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/reset/relations"
      }
    ]
  },
  {
    "type": "delete",
    "url": "/realmedialibrary/v1/reset/slugs",
    "title": "Resets the slugs of all available folders",
    "name": "ResetSlugs",
    "group": "Reset",
    "version": "1.0.0",
    "permission": [
      {
        "name": "manage_options"
      }
    ],
    "filename": "inc/rest/Reset.class.php",
    "groupTitle": "Reset",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/reset/slugs"
      }
    ]
  },
  {
    "type": "get",
    "url": "/realmedialibrary/v1/tree",
    "title": "Get the full categories tree",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "string",
            "optional": true,
            "field": "currentUrl",
            "description": "<p>The current url to detect the active item</p>"
          }
        ]
      }
    },
    "name": "GetTree",
    "group": "Tree",
    "version": "1.0.0",
    "filename": "inc/rest/Service.class.php",
    "groupTitle": "Tree",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/tree"
      }
    ]
  },
  {
    "type": "get",
    "url": "/realmedialibrary/v1/tree/dropdown",
    "title": "Get the full categories tree as dropdown options (HTML)",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "string",
            "optional": true,
            "field": "selected",
            "description": "<p>The selected folder id</p>"
          }
        ]
      }
    },
    "name": "GetTreeDropdown",
    "group": "Tree",
    "version": "1.0.0",
    "filename": "inc/rest/Service.class.php",
    "groupTitle": "Tree",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/tree/dropdown"
      }
    ]
  },
  {
    "type": "put",
    "url": "/realmedialibrary/v1/hierarchy/:id",
    "title": "Change a folder position within the hierarchy",
    "parameter": {
      "fields": {
        "Parameter": [
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "id",
            "description": "<p>The folder id</p>"
          },
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "parent",
            "description": "<p>The parent</p>"
          },
          {
            "group": "Parameter",
            "type": "int",
            "optional": false,
            "field": "nextId",
            "description": "<p>The next id to the folder</p>"
          }
        ]
      }
    },
    "name": "PutHierarchy",
    "group": "Tree",
    "version": "1.0.0",
    "filename": "inc/rest/Service.class.php",
    "groupTitle": "Tree",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/hierarchy/:id"
      }
    ]
  },
  {
    "type": "put",
    "url": "/realmedialibrary/v1/usersettings",
    "title": "Update user settings",
    "description": "<p>Send a key value map of form data so UserSettings implementations (IUsetSettings) can handle it</p>",
    "name": "UpdateUserSettings",
    "group": "UserSettings",
    "version": "1.0.0",
    "filename": "inc/rest/Service.class.php",
    "groupTitle": "UserSettings",
    "sampleRequest": [
      {
        "url": "/wp-json/realmedialibrary/v1/usersettings"
      }
    ]
  }
] });
